"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EMPTY_SVG = exports.COMMIT_MESSAGE_PATTERNS = exports.COMMIT_MESSAGE_PLACEHOLDER = exports.STATUSES = exports.STATE = exports.OPTIONS = void 0;
const ns = (s) => `github/${s}`;
exports.OPTIONS = {
    API: ns `api`,
    BASE: ns `base`,
    COMMIT_CREATE_PATTERN: ns `commitCreate`,
    COMMIT_DELETE_PATTERN: ns `commitDelete`,
    COMMIT_UPDATE_PATTERN: ns `commitUpdate`,
    FILE_EXT: 'assets/fileExt',
    FOLDER_PATH: ns `folderPath`,
    GLOB_PATTERN: 'assets/globPattern',
    HEAD: ns `head`,
    NAME_SCHEME: 'assets/nameScheme',
    OUTPUT_PATH: 'assets/outputPath',
    OWNER: ns `owner`,
    REPO: ns `repo`,
};
exports.STATE = {
    COMPONENT_FILES: 'assets/componentFiles',
    COMPONENT_NAME: 'componentName',
    COMPONENT_NAME_OLD: ns `componentNameOld`,
    DIFF_TYPE: ns `diffType`,
    FILE_PATH: 'filePath',
};
exports.STATUSES = {
    ADDED: 'added',
    MODIFIED: 'modified',
    REMOVED: 'removed',
    RENAMED: 'renamed',
};
exports.COMMIT_MESSAGE_PLACEHOLDER = '${message}';
exports.COMMIT_MESSAGE_PATTERNS = {
    CREATE: `feat: ${exports.COMMIT_MESSAGE_PLACEHOLDER}`,
    DELETE: `refactor: ${exports.COMMIT_MESSAGE_PLACEHOLDER}\n\nBREAKING CHANGE: ${exports.COMMIT_MESSAGE_PLACEHOLDER}`,
    UPDATE: `fix: ${exports.COMMIT_MESSAGE_PLACEHOLDER}`,
};
exports.EMPTY_SVG = '<svg/>';
