"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = __importStar(require("path"));
const minimatch_1 = __importDefault(require("minimatch"));
const utils_1 = require("@react-vector-graphics/utils");
const constants_1 = require("./constants");
const utils_2 = require("./utils");
const findAssets = (_a) => { var folderPath, _b, githubApi, base, githubParams, params; return __awaiter(void 0, void 0, void 0, function* () {
    ({ folderPath = '' } = _a, _b = _a.github, { api: githubApi, base = 'master' } = _b, githubParams = __rest(_b, ["api", "base"]), params = __rest(_a, ["folderPath", "github"]));
    const compareCommitsResult = yield githubApi.repos.compareCommits(Object.assign(Object.assign({}, githubParams), { base }));
    const svgFiles = compareCommitsResult.data.files.filter(file => {
        const isInFolder = file.filename.startsWith(folderPath);
        if (!isInFolder)
            return false;
        const relPath = path.relative(folderPath, file.filename);
        return minimatch_1.default(relPath, utils_2.normaliseGlob(params.globPattern));
    });
    const pluginParams = svgFiles.map((file) => __awaiter(void 0, void 0, void 0, function* () {
        const filePath = path.relative(folderPath, file.filename);
        const { data } = file.status === constants_1.STATUSES.REMOVED
            ? { data: { content: utils_2.toBase64(constants_1.EMPTY_SVG) } }
            : yield githubApi.repos.getContent(Object.assign(Object.assign({}, githubParams), { base, path: file.filename, ref: githubParams.head }));
        if (Array.isArray(data) || !data.content) {
            throw new Error(`Could not get contents for ${file.filename}`);
        }
        return {
            code: utils_2.fromBase64(data.content.toString()),
            state: Object.assign({
                [constants_1.STATE.COMPONENT_NAME]: utils_1.pathToName(filePath, params.nameScheme),
                [constants_1.STATE.COMPONENT_NAME_OLD]: file.previous_filename &&
                    utils_1.pathToName(path.relative(folderPath, file.previous_filename), params.nameScheme),
                [constants_1.STATE.DIFF_TYPE]: file.status,
                [constants_1.STATE.FILE_PATH]: filePath,
            }, params.state),
        };
    }));
    return Promise.all(pluginParams);
}); };
exports.default = findAssets;
