"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.run = void 0;
const constants_1 = require("./constants");
const findAssets_1 = __importDefault(require("./findAssets"));
const writeComponent_1 = __importDefault(require("./writeComponent"));
exports.run = (code, config, state, logger) => __awaiter(void 0, void 0, void 0, function* () {
    var _a;
    const github = {
        api: config.options[constants_1.OPTIONS.API],
        base: config.options[constants_1.OPTIONS.BASE],
        head: config.options[constants_1.OPTIONS.HEAD],
        owner: config.options[constants_1.OPTIONS.OWNER],
        repo: config.options[constants_1.OPTIONS.REPO],
    };
    const sharedArgs = {
        folderPath: config.options[constants_1.OPTIONS.FOLDER_PATH],
        github,
    };
    if (code) {
        yield writeComponent_1.default(Object.assign(Object.assign({}, sharedArgs), { assetFile: state[constants_1.STATE.FILE_PATH], code, commitMessagePatterns: {
                create: config.options[constants_1.OPTIONS.COMMIT_CREATE_PATTERN],
                delete: config.options[constants_1.OPTIONS.COMMIT_DELETE_PATTERN],
                update: config.options[constants_1.OPTIONS.COMMIT_UPDATE_PATTERN],
            }, componentFiles: (_a = state[constants_1.STATE.COMPONENT_FILES]) !== null && _a !== void 0 ? _a : {}, componentName: state[constants_1.STATE.COMPONENT_NAME], componentNameOld: state[constants_1.STATE.COMPONENT_NAME_OLD], diffType: state[constants_1.STATE.DIFF_TYPE], fileExt: config.options[constants_1.OPTIONS.FILE_EXT], logger, outputPath: config.options[constants_1.OPTIONS.OUTPUT_PATH] }));
        return { code, state };
    }
    else {
        return findAssets_1.default(Object.assign(Object.assign({}, sharedArgs), { globPattern: config.options[constants_1.OPTIONS.GLOB_PATTERN], nameScheme: config.options[constants_1.OPTIONS.NAME_SCHEME], state }));
    }
});
