"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.eagerPromises = exports.toBase64 = exports.fromBase64 = exports.replaceAll = exports.normaliseGlob = void 0;
// https://github.com/isaacs/minimatch/issues/30
exports.normaliseGlob = (globPattern) => {
    if (globPattern.startsWith('./')) {
        return globPattern.substring(2);
    }
    return globPattern;
};
exports.replaceAll = (str, search, replacement) => str.split(search).join(replacement);
exports.fromBase64 = (data) => Buffer.from(data, 'base64').toString();
exports.toBase64 = (data) => Buffer.from(data).toString('base64');
exports.eagerPromises = (
// eslint-disable-next-line @typescript-eslint/no-explicit-any
promises, logger = console) => Promise.all(promises.map(p => p.catch(logger.error)));
